#include <stdio.h>
#include <stdlib.h>
#include "dlgfracparams.h"
#include "dlgfracparams.moc"

FracParamsDlg::FracParamsDlg(DrawWidget* Clnt, QWidget* parent=0, const char* name=0):
     QTabDialog (parent, name, TRUE, WStyle_DialogBorder)
{
int Lauf;
char Strg[128];
QLabel *ParLab[16];

//fprintf(stdout,"FracParamsDlg::FracParamsDlg\n");

   setCaption("Fractal-Parameters");
   //setFocusPolicy(QWidget::StrongFocus);
   Client = Clnt;
   Fractal = Client->Fractal;

   QWidget* General = new QWidget(this, "General");
   // Iterationen
   MaxIterSpin = new KNumericSpinBox(General, "MaxIterSpin");
   MaxIterSpin->setGeometry(130,30,80,22);
   MaxIterSpin->setRange(1,10000000);
   MaxIterSpin->setEditable(TRUE);
   QPushButton* PPBtn = new QPushButton("++", General, "PPBtn");
   PPBtn->setGeometry(212,30,15,11);
   connect(PPBtn,SIGNAL(clicked()), this, SLOT(PPBtnClick()));
   QPushButton* MMBtn = new QPushButton("--", General, "MMBtn");
   MMBtn->setGeometry(212,41,15,11);
   connect(MMBtn,SIGNAL(clicked()), this, SLOT(MMBtnClick()));

   QLabel *MaxIterLab = new QLabel("Maxiter:",General);
   MaxIterLab->setGeometry(20,30,45,20);
   // Rechenmethode
   QLabel* CalcLabel = new QLabel("Calcmode:", General, "CalcLabel");
   CalcLabel->setGeometry(20,60,60,15);
   CalcCombo = new QComboBox(General, "CalcCombo");
   CalcCombo->setGeometry(130,60,120,20);
   CalcCombo->insertItem("Line by Line");
   CalcCombo->insertItem("Rectangles");
   CalcCombo->setCurrentItem(Client->CalcMethod);

   // Eckpunkte
   QWidget* Corners = new QWidget(this, "Corners");

   MinXEdit = new QLineEdit(Corners, "MinXEdit");
   MaxXEdit = new QLineEdit(Corners, "MaxXEdit");
   MinYEdit = new QLineEdit(Corners, "MinYEdit");
   MaxYEdit = new QLineEdit(Corners, "MaxYEdit");

   MinXEdit->setGeometry( 70,50,125,22);
   MinYEdit->setGeometry(220,50,125,22);
   MaxXEdit->setGeometry( 70,80,125,22);
   MaxYEdit->setGeometry(220,80,125,22);

   QLabel *MinLab = new QLabel("Min:", Corners);
   QLabel *MaxLab = new QLabel("Max:", Corners);
   QLabel *ReLab  = new QLabel("Real:", Corners);
   QLabel *ImLab  = new QLabel("Imag:", Corners);

   MinLab->setGeometry(20,50,45,20);
   MaxLab->setGeometry(20,80,45,20);
   ReLab->setGeometry(70,28,45,20);
   ImLab->setGeometry(220,28,45,20);

   QPushButton* DefBtn = new QPushButton("Defaults", Corners, "DefBtn");
   DefBtn->setGeometry(160, 130,80,30);
   connect(DefBtn, SIGNAL(clicked()), this, SLOT(DefaultCorners()) );

   sprintf(Strg, "%0.14f", Fractal->li);   MinXEdit->setText(Strg);
   sprintf(Strg, "%0.14f", Fractal->re);   MaxXEdit->setText(Strg);
   sprintf(Strg, "%0.14f", Fractal->un);   MinYEdit->setText(Strg);
   sprintf(Strg, "%0.14f", Fractal->ob);   MaxYEdit->setText(Strg);


   // Convergency
   QWidget* Konvergenz = new QWidget(this, "Convergency");
   MaxIterSpin->setValue(Fractal->MaxIter);

   // Konvergenzlimit (Bailout)
   BailEdit = new QLineEdit(Konvergenz, "BailEdit");
   BailEdit->setGeometry(130,30,125,22);
   QLabel* BailLab = new QLabel("Bailout:", Konvergenz, "BailLab");
   BailLab->setGeometry(20,30,100,20);
   // Konvergenzmethode
   QStrList* ConvList = new QStrList;
   ConvList->append("Default");
   ConvList->append("Real");
   ConvList->append("Imag");
   ConvList->append("And");
   ConvList->append("Or");
   ConvSpin = new KListSpinBox(ConvList, Konvergenz, "ConvSpin");
   ConvSpin->setGeometry(130,60,125,22);
   QLabel* ConvLab = new QLabel("Convfunc:", Konvergenz, "ConvLab");
   ConvLab->setGeometry(20,60,80,20);

   ConvSpin->setIndex(Fractal->ConvMode);
   sprintf(Strg, "%0.14f", Fractal->BailOut);   BailEdit->setText(Strg);

   // Seite Postcompute
   QWidget* PostCompute = new QWidget(this, "PostCompute");
   QGroupBox* InsideGroup = new QGroupBox("Inside Parameters", PostCompute, "InsideGroup");
   InsideGroup->setGeometry(10,10,380,100);
   QLabel* InsideLabel = new QLabel("Inside", InsideGroup, "InsideLabel");
   InsideLabel->setGeometry(10,20,60,14);
   InsideCombo = new QComboBox(InsideGroup, "InsideCombo");
   InsideCombo->setGeometry(90,20,120,20);
   InsideCombo->insertItem("Color X");
   InsideCombo->insertItem("Maxiter");
   InsideCombo->setCurrentItem(Fractal->InsideMethod);

   QLabel* InsideColorLabel = new QLabel("Insidecolor", InsideGroup, "InsideColorLabel");
   InsideColorLabel->setGeometry(10,50,70,20);
   InsideColorSpin = new KNumericSpinBox(InsideGroup, "InsideColorSpin");
   InsideColorSpin->setGeometry(90,50,80,22);
   InsideColorSpin->setRange(0,255);
   InsideColorSpin->setEditable(TRUE);
   InsideColorSpin->setValue(Fractal->InsideColor);

   QGroupBox* OutsideGroup = new QGroupBox("Outside Parameters", PostCompute, "OutsideGroup");
   OutsideGroup->setGeometry(10,120,380,155);
   QLabel* OutsideLabel = new QLabel("Outside", OutsideGroup, "OutsideLabel");
   OutsideLabel->setGeometry(10,20,60,14);
   OutsideCombo = new QComboBox(OutsideGroup, "OutsideCombo");
   OutsideCombo->setGeometry(90,20,120,20);
   OutsideCombo->insertItem("Iter");
   OutsideCombo->insertItem("Color X");
   OutsideCombo->insertItem("Potential");
   OutsideCombo->insertItem("Multiply");
   OutsideCombo->setCurrentItem(Fractal->OutsideMethod);
   
   // OutsideColor
   QLabel* OutsideColorLabel= new QLabel("Outsidecolor:", OutsideGroup, "OutsideColorLabel");
   OutsideColorLabel->setGeometry(10,50,60,14);
   OutsideColorSpin = new KNumericSpinBox(OutsideGroup, "OutsideColorSpin");
   OutsideColorSpin->setGeometry(90,50,80,22);
   OutsideColorSpin->setRange(0,255);
   OutsideColorSpin->setEditable(TRUE);
   OutsideColorSpin->setValue(Fractal->OutsideColor);

   // Potentialvalue
   QLabel* PotentialLabel = new QLabel("Potential:", OutsideGroup, "PotentialLabel");
   PotentialLabel->setGeometry(10,80,60,14);
   PotentialEdit = new QLineEdit(OutsideGroup, "PotentialEdit");
   PotentialEdit->setGeometry(90,80,125,22);
   sprintf(Strg, "%f", Fractal->PotentialSlope);
   PotentialEdit->setText(Strg);

   // Seite Parameter (allgemein)
   QWidget* Params = new QWidget(this, "Parameter");
   QLabel* WarnLab1 = new QLabel("These are type-independ parameters", Params,"WarnLab1");
   WarnLab1->setGeometry(10,10,380,15);
   QLabel* WarnLab2 = new QLabel("see also 'type-specific', if any...", Params,"WarnLab2");
   WarnLab2->setGeometry(10,25,380,15);
   // Parameter
   for (Lauf=0; Lauf<16; Lauf++) {
      sprintf(Strg, "p%d", Lauf);
      ParLab[Lauf] = new QLabel(Strg, Params, Strg);
      ParLab[Lauf]->setGeometry(20+(Lauf/8)*195,60+25*(Lauf%8),30,22);
      Par[Lauf]=new QLineEdit(Params, Strg);
      Par[Lauf]->setGeometry(45+(Lauf/8)*200,60+25*(Lauf%8),130,22); 

      sprintf(Strg, "%0.14f", Fractal->p[Lauf]);
      Par[Lauf]->setText(Strg);
   }
   QPushButton* DefParamsBtn = new QPushButton("Defaults", Params, "DefParamsBtn");
   DefParamsBtn->setGeometry(290,10,80,30);
   connect(DefParamsBtn, SIGNAL(clicked()), this, SLOT(DefaultParameters()) );

   // Seite Info
   QWidget* Info = new QWidget(this, "Info");
   FracNr   = new QLabel("", Info, "FracNr");
   FracNr->setGeometry(10,10,280,20);
   FracName = new QLabel("", Info, "FracName");
   FracName->setGeometry(10,35,280,20);
   FracInfo = new QLabel("", Info, "FracInfo");
   FracInfo->setGeometry(10,70,450,200);
   FracInfo->setAlignment(AlignLeft+AlignTop);

   sprintf(Strg,"internal number : %d", Fractal->GetFracType());
   FracNr->setText(Strg);
   sprintf(Strg,"Fractalname : %s", Fractal->GetFracName());
   FracName->setText(Strg);
   FracInfo->setText(Fractal->GetFracInfo());

   addTab(General, "General");
   addTab(Corners, "Corners");
   addTab(Konvergenz, "Convergency");
   addTab(PostCompute, "Postcompute");
   addTab(Params, "Parameters");
   addTab(Info, "Information");

   // setOKButton();
   setFixedSize(400,350);
   setCancelButton();
}

/*void FracParamsDlg::SetCornerParams(double x1, double y1, double x2, double y2)
// Alle Parameter auf der Seite "General" setzen
{
   char strg[20];

   sprintf(strg, "%0.14f", x1);   MinXEdit->setText(strg);
   sprintf(strg, "%0.14f", x2);   MaxXEdit->setText(strg);
   sprintf(strg, "%0.14f", y1);   MinYEdit->setText(strg);
   sprintf(strg, "%0.14f", y2);   MaxYEdit->setText(strg);
}

int FracParamsDlg::GetCornerParams(double *x1, double *y1, double *x2, double *y2)
// Alle Parameter auf der Seite "General" lesen
{
   char *eptr;
   double X1,X2,Y1,Y2;

   //fprintf(stdout,"s=>%s<\n",MinXEdit->text());
   eptr=NULL;
   X1 = strtod(MinXEdit->text(), &eptr);
//fprintf(stdout,"eptr=>%s<\n",eptr);
   if (*eptr!=0) return FALSE;
//fprintf(stdout,"x1 ok\n");   

   X2 = strtod(MaxXEdit->text(), &eptr);
   if (*eptr!=0) return FALSE;
   
   Y1 = strtod(MinYEdit->text(), &eptr);
   if (*eptr!=0) return FALSE;
   
   Y2 = strtod(MaxYEdit->text(), &eptr);
   if (*eptr!=0) return FALSE;
   
   *x1=X1;  *y1=Y1;  *x2=X2;  *y2=Y2; 
   return TRUE;
}

void FracParamsDlg::SetGeneralParams(int MaxIter)
{
//char strg[32];

   MaxIterSpin->setValue(MaxIter);
}

int FracParamsDlg::GetGeneralParams(int* MaxIter)
{
//fprintf(stdout,"Maxiter=%d\n",*MaxIter);
   *MaxIter=MaxIterSpin->getValue();
   return TRUE;
}

void FracParamsDlg::SetConvParams(int ConvMode, double BailOut)
{
char strg[32];

   ConvSpin->setIndex(ConvMode);
   sprintf(strg, "%0.14f", BailOut);   BailEdit->setText(strg);
}

int FracParamsDlg::GetConvParams(int* ConvMode, double* BailOut)
{
   char* eptr=NULL;
   double Bail;

   Bail = strtod(BailEdit->text(), &eptr);
   if (*eptr!=0) return FALSE;

   *BailOut = Bail;
   *ConvMode=ConvSpin->getIndex();
   return TRUE;
}

void FracParamsDlg::SetParamParams(double *p)
{
char Strg[32];
int Lauf;

   for (Lauf=0; Lauf<16; Lauf++) {
      sprintf(Strg, "%0.14f", *p);
      p++;
      Par[Lauf]->setText(Strg);
   }
}

int FracParamsDlg::GetParamParams(double *p)
{
double f[16];
int Lauf;
char *eptr=NULL;

   for (Lauf=0; Lauf<16; Lauf++) {
      f[Lauf] = strtod(Par[Lauf]->text(), &eptr);
      if (*eptr!=0){
         // fprintf(stdout,"error %d  >%s<\n",Lauf,Par[Lauf]->text());
         return FALSE;
      }
   }
   
   for (Lauf=0; Lauf<16; Lauf++) {
      *p = f[Lauf];
      p++;
   }
   return TRUE;
}

void FracParamsDlg::SetInfoParams(int Nr, char* Name, char* InfoText)
{
char Strg[128];

   sprintf(Strg,"internal number : %d", Nr);
   FracNr->setText(Strg);
   sprintf(Strg,"Fractalname : %s", Name);
   FracName->setText(Strg);
   FracInfo->setText(InfoText);
}
*/
void FracParamsDlg::DefaultCorners()
// Eckpunkte auf die Startup-Werte setzen
{
char strg[32];
double a,b,c,d;
//fprintf(stdout,"DefaultCorners()\n");

   Fractal->SetDefaultCorners(&a,&b,&c,&d);
   sprintf(strg, "%0.14f", a);   MinXEdit->setText(strg);
   sprintf(strg, "%0.14f", b);   MaxXEdit->setText(strg);
   sprintf(strg, "%0.14f", c);   MinYEdit->setText(strg);
   sprintf(strg, "%0.14f", d);   MaxYEdit->setText(strg);
}

void FracParamsDlg::DefaultParameters()
{
char Strg[32];
int Lauf;

   for (Lauf=0; Lauf<16; Lauf++) {
      sprintf(Strg, "%0.14f", Fractal->SetDefaultParams(Lauf));
      Par[Lauf]->setText(Strg);
   }
}

char* FracParamsDlg::SetParams(void)
// Alle Parameter in das Fraktalobjekt zurckschreiben
{
   char* eptr;
   int Lauf;
   double li,re,un,ob;   // Eckpunkte
   int MaxIter;          // Iterationstiefe;
   int ConvMode;         // Konvergenztestmenthode
   double BailOut;       // Grenzwert
   double p[16];         // Float-Params;
   int InsMode,OutMode;  // Rechenmodi Inside & Outside
   int InsCol, OutCol;   // Farben       "         "
   double PotSlope;      // Potential
   int CalcM;            // Rechenmethode

   // Seite Corners
   eptr=NULL;
   li = strtod(MinXEdit->text(), &eptr);
   if (*eptr!=0) return "XMin";

   re = strtod(MaxXEdit->text(), &eptr);
   if (*eptr!=0) return "XMax";
   
   un = strtod(MinYEdit->text(), &eptr);
   if (*eptr!=0) return "YMin";
   
   ob = strtod(MaxYEdit->text(), &eptr);
   if (*eptr!=0) return "YMax";

   // Seite General
   MaxIter=MaxIterSpin->getValue();
   CalcM = CalcCombo->currentItem();

   // Seite Convergency
   BailOut = strtod(BailEdit->text(), &eptr);
   if (*eptr!=0) return "BailOut";
   ConvMode=ConvSpin->getIndex();

   // Seite Postcompute
   PotSlope = strtod(PotentialEdit->text(), &eptr);
   if (*eptr!=0) return "PotSlope";
   InsMode = InsideCombo->currentItem();
   OutMode = OutsideCombo->currentItem();
   InsCol = InsideColorSpin->getValue();
   OutCol = OutsideColorSpin->getValue();

   // Seite Parameters (float)
   for (Lauf=0; Lauf<16; Lauf++) {
      p[Lauf] = strtod(Par[Lauf]->text(), &eptr);
      if (*eptr!=0){
         // fprintf(stdout,"error %d  >%s<\n",Lauf,Par[Lauf]->text());
         return "Float-params";
      }
   }
   
   Fractal->li = li;
   Fractal->re = re;
   Fractal->un = un;
   Fractal->ob = ob;
   Fractal->MaxIter = MaxIter;
   Fractal->ConvMode = ConvMode;
   Fractal->BailOut = BailOut;
   for (Lauf=0; Lauf<16; Lauf++) Fractal->p[Lauf] = p[Lauf];
   Fractal->InsideMethod = InsMode;
   Fractal->OutsideMethod = OutMode;
   Fractal->InsideColor = InsCol;
   Fractal->OutsideColor = OutCol;
   Fractal->PotentialSlope = PotSlope;
   Client->CalcMethod = CalcM;

   return NULL;
}

void FracParamsDlg::PPBtnClick() {

   MaxIterSpin->setValue(MaxIterSpin->getValue()+25);
}

void FracParamsDlg::MMBtnClick() {

   if (MaxIterSpin->getValue()>25)
      MaxIterSpin->setValue(MaxIterSpin->getValue()-25);
}
